/******************************************************************
 * Qiang Zheng,
 * ECS Dept, Syracuse Univ. Nov. 10, 1999
 * for CIS 615 class, Spring, 2000,
 * Instructor: Geoffrey C Fox, Nancy McCracken
 * O.S.: Solaris  Environment: VPL
 * Libraries: mpilib.a
 *
 * Purpose: timing a token passing process
 * based on Example for CPS615 - Homework 3  -- Saleh Elmohamed
 ******************************************************************/

#include	<stdio.h>
#include	<mpi.h>

#define tag 0
void main (int argc, char *argv[])
{
  int myId, procNum, right, left, token ;
  double start, finish, time=0.0, avgTime;
  MPI_Status  stat;
  MPI_Request sendReq, recvReq;

  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &myId);
  MPI_Comm_size(MPI_COMM_WORLD, &procNum);

  left=( myId-1+procNum )%procNum;
  right=( myId+1+procNum )%procNum;
  token=myId;

  do {

    start = MPI_Wtime();
    MPI_Isend( &token, 1, MPI_INT, right, tag, MPI_COMM_WORLD, &sendReq );
    MPI_Irecv( &token, 1, MPI_INT, left, tag, MPI_COMM_WORLD, &recvReq );
    MPI_Wait( &sendReq, &stat );
    MPI_Wait( &recvReq, &stat );
    finish=MPI_Wtime();
    time+=finish-start;
  } while ( token!=myId );

  avgTime=time/( double )procNum;
  printf("The average time happened in processor %d in passing a token to the neighbour in a ring is %f\n"
    , myId, avgTime);

  MPI_Finalize();

}
